The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Mandolin Class Reference

STK mandolin instrument model class. More...

`#include <Mandolin.h>`

Inheritance diagram for stk::Mandolin:

## Public Member Functions
| Mandolin (StkFloat lowestFrequency)
| Class constructor, taking the lowest desired playing frequency.
| ~Mandolin (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setDetune (StkFloat detune)
| Detune the two strings by the given factor. A value of 1.0 produces unison strings.
void | setBodySize (StkFloat size)
| Set the body size (a value of 1.0 produces the "default" size).
void | setPluckPosition (StkFloat position)
| Set the pluck or "excitation" position along the string (0.0 - 1.0).
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | pluck (StkFloat amplitude)
| Pluck the strings with the given amplitude (0.0 - 1.0) using the current frequency.
void | pluck (StkFloat amplitude, StkFloat position)
| Pluck the strings with the given amplitude (0.0 - 1.0) and position (0.0 - 1.0).
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude (0.0 - 1.0).
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs. More...
Public Member Functions inherited from stk::Instrmnt
| Instrmnt (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed frame. More...
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK mandolin instrument model class.

This class uses two "twang" models and "commuted synthesis" techniques to model a mandolin instrument.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others. Commuted Synthesis, in particular, is covered by patents, granted, pending, and/or applied-for. All are assigned to the Board of Trustees, Stanford University. For information, contact the Office of Technology Licensing, Stanford University.

Control Change Numbers:

- Body Size = 2
- Pluck Position = 4
- String Sustain = 11
- String Detuning = 1
- Microphone Position = 128

by Perry R. Cook and Gary P. Scavone, 1995–2019.

## Member Function Documentation

## ◆ tick()

StkFrames & stk::Mandolin::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

115 {
116 unsigned int nChannels = lastFrame_.channels();
117 #if defined(_STK_DEBUG_)
118 if ( channel > frames.channels() - nChannels ) {
119 oStream_ << "Mandolin::tick(): channel and StkFrames arguments are incompatible!";
120 handleError( StkError::FUNCTION_ARGUMENT );
121 }
122 #endif
123
124 StkFloat *samples = &frames[channel];
125 unsigned int j, hop = frames.channels() - nChannels;
126 if ( nChannels == 1 ) {
127 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
128 *samples++ = tick();
129 }
130 else {
131 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
132 *samples++ = tick();
133 for ( j=1; j<nChannels; j++ )
134 *samples++ = lastFrame_[j];
135 }
136 }
137
138 return frames;
139 }

The documentation for this class was generated from the following file:

- Mandolin.h

stk::StkFrames::channels
unsigned int channels(void) const
Return the number of channels represented by the data.
Definition: Stk.h:404
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::Mandolin::tick
StkFloat tick(unsigned int channel=0)
Compute and return one output sample.
Definition: Mandolin.h:101

The Synthesis ToolKit in C++ (STK)
©1995--2019 Perry R. Cook and Gary P. Scavone. All Rights Reserved.